Scriptname WZones_childDisabler extends ObjectReference  

{

WARZONES STEP 3
Disables and Deletes ALL WZNPCs spawned by PLACEATME via WZONESSpawnOMany script.

In theory (and hopefully in practice, this removes the Orphaned WZNPCs from memory and the game. 

}

bool bWZTraceLog = false ; Controller marker for Tracelog inclusion DEV use. - Deapri
int UpdateWaitTime = 60
ActorBase Property WZONESvSPAWN Auto  
	{ OBSOLETE : This is a SELF CHECK script.  Script doesn't use this, but you can set it if you'll feel better. }

; ====== Events


	Event OnUnLoad()

		;While !Self.Is3DLoaded()
		disable()
		deletewhenable()
						
			If bWZTraceLog == True
				debug.Trace ("WZMSG : Player Left the WZ so we Murdered the Grandkids")
			Else
			Endif
		
		;EndWhile
		
	endEvent
	
	Event OnCellDetach()
		disable()
		deletewhenable()
	EndEvent



STATE WZ2015ChildDisableCooldown
; For safe keeping.  I think this is causing too many scripts to stay in memory and therefore causing Stack overflows... reverting to the older version to see if that corrects it.
	Event OnLoad()

		Utility.WaitGameTime(12.0) ; Wait in GameHours
		RegisterForSingleUpdate(1)

	EndEvent

	Event OnUpdate()
	
		While Self.Is3DLoaded() ; I am visible and probably should be, so let's wait a bit for the player to walk away.
			RegisterForSingleUpdate(UpdateWaitTime)
		EndWhile
		
		While !Self.Is3DLoaded() ; I've been unloaded and if I'm still hanging around, delete me
			Disable()
			Delete()
			GotoState("done")
		EndWhile

	EndEvent

EndState	

; ===== States

	State Done
		Event OnBeginState()
			; debug.Notification ("We are done here")
		EndEvent
	EndState

	State OLD_ONUNLOAD_FOR_SAFE_KEEPING
	
		; This was the original ChildKiller as of 10/4/2014
		; Trying this new version to prevent the WZs from repopulating every time a player enters and exits an interior that has a WZ nearby
		
		Event OnUnLoad()

		;While Self.Is3DLoaded()
		disable()
		deletewhenable()
						
			If bWZTraceLog == True
				debug.Trace ("WZMSG : Player Left the WZ so we Murdered the Grandkids")
			Else
			Endif
		
		;EndWhile
		
		endEvent

	EndState