Scriptname wzones_cooldown extends ObjectReference  

{ REQUIRES AN ENABLE PARENT!

Prevent WARZONES from respawning immediately by adjusting the GLOBAL VARIABLE for the BATTLESELECT 
to "2" for X period of time.  This does not need to be ENABLEDPARENTED as it checks the gVar on its own. }

	GlobalVariable Property WZonesCooldown Auto 
		{  DEFAULT = 12.0 = 12 Game hours : A cooldown to have this stop checking for Enable after its made its "decision".  Allows the WZ to remain the same (whether Enabled or Randomly Disabled for a specific GameTime.  }
		
	GlobalVariable Property WZonesDebugMsg Auto
		{ ; === Sets WZ DebugTrace Messages (0 = Off, 2 = Primary MSGs on, 3 = All MSGS on) }
		
	GlobalVariable Property WZonesSelectiveBattles Auto 
		{ ; === BATTLE SELECT Via PROPERTIES will hold the status of named Warzones. 
			WZONESSELECTIVEBATTLES manually assigned in PROPERTIES. 
					Points to WZonesSelectXXXXXX value
					WZonesSelectXXXXXX value is default 1
					0 = disable / cooling down (theoretically this allows for re-enabling via MCM before cooldown is over) 
					1 = enable for game conditions 
					666 = Override and display }
	
	;int Property Dev_AddTime = 0 Auto
	
	;int USERWZSETTING
	

	
Event OnCellDetach()

	If parent.isEnabled()
	
		If WZONESSELECTIVEBATTLES.getValue() == 1
			WZONESSELECTIVEBATTLES.setValue(0)
					If WZonesDebugMsg.Value >= 2
						debug.Trace ("WZMSG[2] : COOLDOWN : Waiting @" + WZONESSELECTIVEBATTLES)
					Else
					Endif
			Utility.WaitGameTime(WZonesCooldown.Value)
					If WZonesDebugMsg.Value >= 2
						debug.Trace ("WZMSG[2] : COOLDOWN : Over @" + WZONESSELECTIVEBATTLES)	
					Else
					Endif			
			WZONESSELECTIVEBATTLES.setValue(1)
		EndIf
	
	EndIf
EndEvent