Scriptname WZones_RandomEncounters extends ObjectReference  

{

Somewhat misnamed, this script CHECKS FOR CW RANDOM ENCOUNTERS and ENABLES them based on the Player's RandomEncounterOdds

In effect, this is about the same as the RANDOM ENABLER script, but removing it from base objects caused errors, so I left it in.

For ALL other RANDOM SPAWN uses, the newer RANDOM ENABLER script is recommended.

}


bool bWZTraceLog = true ; Controller marker for Tracelog inclusion DEV use. - Deapri

Int Property RandomChanceOffset  Auto  ;==== DEVELOPER inputs value to increase odds of ENABLE

Bool Property DoesCWMatterInThisLocation Auto ; ---- Determines if CW check is necessary.  Use for NonCW WZs.

Quest Property CWOBJ Auto hidden
Quest Property MQ302 Auto hidden;    = Checks the CW TRUCE.  300 = TRUCE
Quest Property MQ305 Auto hidden;    = Checks if Alduin is dead and therefore truce is over

GlobalVariable Property WZonesCWStatus Auto hidden ; === checks the WZONES civil war status so this can disable CW encounters after the CW is over.
GlobalVariable Property WZonesCWTruce Auto hidden ; = Is there a CW TRUCE?  0 = No, 1 = Yes
GlobalVariable Property WZonesOverride Auto hidden; === Override all conditions
GlobalVariable Property WZonesSpawnCount Auto ; === Global variable where iX is stored
GlobalVariable Property WZonesRandomEncounters Auto ; === ( 0 = OFF, 1 = ON)
GlobalVariable Property WZonesDebugMsg Auto hidden ; === (WZ Debug Message Levels : 0 = off, 1 = Major, 2 = Minor, 3 = Low Priority)

GlobalVariable Property WZonesRandomEncounterOdds Auto 
; === User can choose to increase/decrease the odds of a random encounter.  Should really be considered as PERCENTAGE chance.  So if set for 10, there's a 10% chance.  If set for 100, there's a 100% chance.
; === Default = 1 in 100.

Event OnCellAttach()

;------- Check to see if these are disabled and if so, don't bother with the condition checks

		if WZonesRandomEncounters.getValue() == 0  
				While Self.Is3DLoaded()
				disable()
				EndWhile
			gotoState ("doOnce")
		endif

;------- Check END of CIVIL WAR regardless of winner

	if (CWOBJ.GetStageDone(255))
		WZONESCWStatus.setValue(1)
	endif
	
	if (MQ302.GetStageDone(300)) 
		 WZonesCWTruce.setValue(1)
			If WZonesCWTruce.getValue() == 1 && (MQ305.GetStageDone(200))
			WZonesCWTruce.setValue(0)
			Else
			EndIf
		Else
	 EndIf	

;------- And finally check to see if the random number was generated to spawn an Encounter

	int randomDiceRoll = Utility.RandomInt (1, 100) ; Roll the Dice for a 1 in 100 chance that there should be an encounter.
	int randomEncounterOdds = WZonesRandomEncounterOdds.Value As Int ; USER INPUT number 0 = no chance 100 = total chance
				
									;If WZonesDebugMsg.Value >= 1
										;debug.Trace ("WZMSG[1] : RandomEncountersScript : PLAYER has ENTERED a RANDOM ENCOUNTER Area... roll 'dem bones"+" @ " +GetParentCell())
										If WZonesDebugMsg.Value >= 2
											debug.Trace ("WZMSG[2] : RandomEncountersScript : " +GetParentCell()+ " : RandomDICEroll = " + randomDiceRoll)
											debug.Trace ("WZMSG[2] : RandomEncountersScript : " +GetParentCell()+ " : EncounterOdds + DevOffset = " + (randomEncounterOdds + RandomChanceOffset))
										Endif
									;Else
									;Endif

				;----- Is the CW happening?  
				;----- If not, disable
				;----- Can be set to NONE in properties if the battle isn't CW related.
	
		If WZonesOverride.getValue() == 666 ; Is WZ Overridden?
				While Self.Is3DLoaded()
				disable()
				EndWhile

									If WZonesDebugMsg.Value >= 2
										debug.Trace ("WZMSG[2] : RandomEncountersScript : " +GetParentCell()+ " : DISABLED by OVERRIDE 666")
									Else
									Endif
				gotoState ("doneOnce")					
	;-------- Check the status of the CIVIL WAR
	;-------- Assigned above in this script

		ElseIf (DoesCWMatterInThisLocation == true && WZonesCWStatus.getValue() == 1) || (DoesCWMatterInThisLocation == true && WZONESCWTruce.getValue() == 1)
				While Self.Is3DLoaded()
				disable()
				EndWhile
									If WZonesDebugMsg.Value >= 1
									debug.Trace ("WZMSG[1] : RandomEncountersScript :" +GetParentCell()+ " : DISABLED by CW STATUS")
									Else
									Endif
				gotoState ("doneOnce")						

		ElseIf randomEncounterOdds + RandomChanceOffset <= randomDiceRoll ; Did the Random Number Generate a WINNER?
				While Self.Is3DLoaded()
				disable()
				EndWhile
									If WZonesDebugMsg.Value >= 1
									debug.Trace ("WZMSG[1] : RandomEncountersScript : " +GetParentCell()+ " : Disabled : High dice")
									EndIf		
				gotoState ("doneOnce")		
			
;------ ENABLE!!!!

		else
				While !Self.Is3DLoaded()
				enable()
				EndWhile
									If WZonesDebugMsg.Value >= 1
									debug.Trace ("WZMSG[1] : RandomEncountersScript : " +GetParentCell()+ " : ENABLED!")
									endif
				Gotostate ("doneOnce")										

		endif	
	
Endevent

State doneOnce
	; Extra Stopgap
	; Do Nothing until reset
	Event OnBeginState()
									If WZonesDebugMsg.Value >= 4	
										debug.Trace ("WZMSG[4] : RandomEncountersScript : " +GetParentCell()+ " : State DoneOnce")
									Else
									Endif
	EndEvent
	
	Event OnUnload()
				While Self.Is3DLoaded()
				disable()
				EndWhile
									If WZonesDebugMsg.Value >= 4
									debug.Trace ("WZMSG[4] : RandomEncountersScript : " +GetParentCell()+ " : PLAYER Exited Area : Disable")
									EndIf		
	EndEvent	

EndState
