Scriptname WZONESCWGetStatusNoSpawnOMeter extends ObjectReference  

{
	WARZONES STEP ONE:
	
	WARZONES primary WZNPC "STATUS CHECKER".  
	Used ONLY on WZ PARENTS which will then enable/disable the WZNPCs which are ENABLE PARENTed
	
	
	Contains: 
	CIVILWAR : WZonesCWStatus (0 = ON, 1 = OVER)
	SELECTIVE BATTLE : variable WZONESSelectiveBattles to be set in PROPERTIES
	QUEST CHECK : checks ENABLE and DISABLE quests to be set in PROPERTIES
	
	WARZONES CIVIL WAR Status : Checks for the end of the CIVIL WAR without considering the SPAWN O METER setting.
		Use this on the NPCS related to the entire CIVIL WAR and/or STATIC WARZONES that will STAY ENABLED regardless of SPAWN O METER SETTING.
		Use WZONESCWGetStatusAndDisableIfOver on remaining NPCS.
		Don't use this on NPCs that have been triggered/parented already by QUEST events

		WARZONES CIVIL WAR
			0 = Active
			1 = Over

	WARZONES : Selective Battle Toggle
		PARENT-Status overrides scripted ENABLE/DISABLE (annoyingly)

		Enables the toggling of SELECT BATTLES via the use of script PROPERTIES
		To determine which battle is being toggled, check the PROPERTIES tab for which one is being accessed.

		The variables will be called WZONESSelectXXXXXXX (where XXXXXX is the battle name).

		 0 = DISABLE
		 1 = ENABLE
}


Event OnCellAttach()

; Utility.Wait(0.5)

;======= CONDITION CHECKERS
;======= Placed here to allow for mid-game changes and the like

	;------- Check END of CIVIL WAR regardless of winner

		if (CWOBJ.GetStageDone(255))
			WZONESCWStatus.setValue(1)
					; A value of 1 = CW is over
		endif
		
		 if (MQ302.GetStageDone(300)) 
			 WZONESCWTruce.setValue(1)
				If WZonesCWTruce.getValue() == 1 && (MQ305.GetStageDone(200))
				WZonesCWTruce.setValue(0)
				Else
				EndIf
			Else
		 EndIf	

		 ;------- Check CW FACTION ADVANTAGE status
	;			If NO ADVANTAGE, lock to baseSpawnCount
	;			Otherwise, offset factions as necessary
					; 0 = NONE
					; 1 = IMPERIALS
					; 2 = STORMCLOAKS
	;
	;		This SUBTRACTS NPCs from the Disadvantaged Faction in order to keep Spawncounts lower

									
;			If WZonesAdvantage.Value == 0
;									If WZonesDebugMsg.Value >= 2
;									debug.Trace ("WZMSG[2] : GetStatusScript : ADVANTAGE None")
;									Else
;									Endif
;				WZonesSpawnCountIMPS.Value = WZonesSpawnCount.Value
;				WZonesSpawnCountSONS.Value = WZonesSpawnCount.Value
;	
;			elseIf WZonesAdvantage.Value == 2
;									If WZonesDebugMsg.Value >= 2
;									debug.Trace ("WZMSG[2] : GetStatusScript : ADVANTAGE Stormcloaks")
;									Else
;									Endif
;				WZonesSpawnCountIMPS.Value = WZonesSpawnCount.Value - 1
;				WZonesSpawnCountSONS.Value = WZonesSpawnCount.Value
;
;			
;			elseIf WZonesAdvantage.Value == 1
;									If WZonesDebugMsg.Value >= 2
;									debug.Trace ("WZMSG[2] : GetStatusScript : ADVANTAGE Imperials")
;									Else
;									Endif
;				WZonesSpawnCountSONS.Value = WZonesSpawnCount.Value - 1
;				WZonesSpawnCountIMPS.Value = WZonesSpawnCount.Value

				
;			endIf
	
	
	
;======= THE MEAT AND POTATOS : Check ENABLE/DISABLE
	
	;------- If user hasn't ENABLED all battles, then run our handy-dandy condition checker.
		
	;-------  Check conditions.  Keep it simple.  Keep checking DISABLE CONDITIONS and if none are met, then ENABLE.
	;-------  Linked via ENABLE PARENT tab will override this, sadly.

			int randomNoSpawn = Utility.RandomInt (1, 100) ; Roll the Dice

	; ------ Random Chance of NO SPAWN.  Developer set via SPAWNPERCENTAGE Property.
	; ------ Use 100 for ALWAYS.
	
	; ------ NOTE: This does not take the Player's RandomEncounterOdds into consideration
	; ------ These WZs are intended to be "always on" so long as their Garrison is enabled... but may add to the dynamic nature of the mod.
	; ------ Therefore it is best to keep this at or above 90%
	
									;If WZonesDebugMsg.Value >= 1	
										;debug.Trace ("WZMSG[1] : GetStatusScript : PLAYER has ENTERED a BATTLESELECT WARZONE "  + WZONESSelectiveBattles)
										If WZonesDebugMsg.Value >= 2
											debug.Trace ("WZMSG[2] : GetStatusScript : " +GetParentCell()+ " : RandomNoSpawn = " + randomNoSpawn)
											debug.Trace ("WZMSG[2] : GetStatusScript : " +GetParentCell()+ " : SpawnPercentage = " + SpawnPercentage)
										EndIf
									;Else
									;Endif
									
		If SpawnPercentage <= randomNoSpawn ; Did the Random Number Generate a NO SPAWN Condition?

					While Self.Is3DLoaded()	
					disable()
					EndWhile
									If WZonesDebugMsg.Value >= 1	
										debug.Trace ("WZMSG[1] : GetStatusScript : " +GetParentCell()+ " : BATTLESELECT WARZONE DISABLED : Random NoSpawn " + WZONESSelectiveBattles)
									Else
									Endif	
						gotoState ("doneOnce")	
								
	;------ Check WARZONES OVERRIDER
					;------ 0 = Business as usual
					;------ 1 = Override all conditions and display ALL battles regardless
					;------ 666 = Disable everything and skip any checks

		Elseif WZonesOverride.getValue() == 666
				While Self.Is3DLoaded()
				disable()
				EndWhile
				
				debug.Notification("WARZONES disabled by 666")
									If WZonesDebugMsg.Value >= 1
										debug.Trace ("WZMSG[1] : GetStatusScript : " +GetParentCell()+ " : DISABLED by OVERRIDE 666 "  +  WZonesSelectiveBattles)
									Else
									Endif
				gotoState ("doneOnce")

		Elseif WZonesOverride.getValue() == 1
				Weather CurrentWeather = Weather.GetCurrentWeather()
				CurrentWeather.ForceActive()	
				
				While !Self.Is3DLoaded()
				enable()
				EndWhile
			
					debug.Notification ("WZONE ENABLED by OVERRIDE")
					debug.Notification ("This is a VERY bad idea especially in areas with overlapping fights")
					debug.Notification ("So set me back to 0 and play your game ;) ")
									If WZonesDebugMsg.Value >= 1
										debug.Trace ("WZMSG[1] : GetStatusScript : " +GetParentCell()+ " : ENABLED by OVERRIDE " +  WZonesSelectiveBattles)
									Else
									Endif
				gotoState ("doneOnce")		
				
	;-------- Check SELECTIVE BATTLES
					;-------- WZONESSELECTIVEBATTLES manually assigned in PROPERTIES. 
					;-------- Points to WZonesSelectXXXXXX value
					;-------- WZonesSelectXXXXXX value is default 1
					;-------- 0 = disable  1 = enable for game conditions 666 = Override and display
			
		; 666 = Override and display
		Elseif WZonesSelectiveBattles.getValue() == 666
				Weather CurrentWeather = Weather.GetCurrentWeather()
				CurrentWeather.ForceActive()
				
				While !Self.Is3DLoaded()
				enable()
				EndWhile

									If WZonesDebugMsg.Value >= 1
										debug.trace ("WZMSG[1] : GetStatusScript : " +GetParentCell()+ " : ENABLED by SELECTIVE BATTLE OVERRIDE " + WZonesSelectiveBattles)
									Else
									Endif
				gotoState ("doneOnce")		
				
		; Check Player Preference for whether they shut this WZ off or not.
		Elseif WZonesSelectiveBattles.getValue() == 0
				While Self.Is3DLoaded()
				disable()
				EndWhile
									If WZonesDebugMsg.Value >= 1
										debug.Trace ("WZMSG[1] : GetStatusScript : " +GetParentCell()+ " : DISABLED by BATTLE SELECT " +  WZonesSelectiveBattles)					
									Else
									Endif
				gotoState ("doneOnce")		
				
	;-------- Check the status of the CIVIL WAR
					;-------- Assigned above in this script
					;-------- CW VARIABLE is opposite of others in that 1 = OFF/OVER
					;-------- This checks to see if the CW is over, and if so, turn off IMPvSC
					;-------- Otherwise, if the WZ is Agnostic to the CW or takes place AFTER the CW
					;-------- set the BOOL WZonesDOESCWMATTERINTHISLOCATION to FALSE in PROPERTIES
					;-------- and it will skip the CW test.
					;-------- The gVAR CWDoesNotMatterHere does not work as planned... stooooopid David

					; === If the CW is over AND it matters here, DISABLE
		ElseIf (WZonesDoesCWMatterInThisLocation == true && WZonesCWStatus.getValue() == 1) || (WZonesDoesCWMatterInThisLocation == true && WZONESCWTruce.getValue() == 1)
					While Self.Is3DLoaded()
					disable()
					EndWhile
									If WZonesDebugMsg.Value >= 2
									debug.Trace ("WZMSG[2] : GetStatusScript : " +GetParentCell()+ " : DISABLED by CW STATUS" +  WZonesSelectiveBattles)
									Else
									Endif
				gotoState ("doneOnce")		
				
										;Debug.Notification("WZ: CW Status Check Running " + WZonesCWStatus.getValue() As String)

	;------- Check GARRISON Status and DISABLE if off
					;------- GARRISONREFERENCE manually selected in PROPERTIES
					;------- Select OBJECT REFERENCE which, when enabled, enables this.
					;------- Use this to "hook" onto Vanilla Garrison Markers and the like.
			
		Elseif (WZonesGarrisonReference.IsDisabled())				
				While Self.Is3DLoaded()
				disable()
				EndWhile
										;debug.Notification(("Garrison Disabled by WZones_GSTNS Script"))
									If WZonesDebugMsg.Value >= 1
										debug.Trace ("WZMSG[1] : GetStatusScript : " +GetParentCell()+ " : BATTLESELECT WZ DISABLED by GARRISON Property " +  WZonesSelectiveBattles)
										;debug.Trace ("WZMSG[1] : GetStatusScript : This is not an error.  You have entered a WZ disabled by gameConditions.")
									Else
									Endif
				gotoState ("doneOnce")		
				
;======= TURN IT ON AND KILL! ========================

	;------- Now then, if all is so far allowed then ENABLE this.

		Else
				Weather CurrentWeather = Weather.GetCurrentWeather()
				CurrentWeather.ForceActive()
				
				While !Self.Is3DLoaded()
				enable()
				EndWhile
				
									If WZonesDebugMsg.Value >= 1
										debug.Trace("WZMSG[1] : GetStatusScript : " +GetParentCell()+ " : SPAWNED BATTLESELECT WARZONE : " +  WZonesSelectiveBattles)
									Else
									Endif
				;Utility.WaitGameTime(WaitGameTimeToRecheck)
				gotoState ("doneOnce")		
		Endif
	
	;Utility.WaitGameTime(WaitGameTimeToRecheck)
	
Endevent

Event OnUnload()
				While Self.Is3DLoaded()
				disable()
				EndWhile
EndEvent

Event OnCellDetach()
				While Self.Is3DLoaded()
				disable()
				EndWhile
EndEvent

;========== STATES

State WarzonesOverride
		Event OnCellAttach()
			Weather CurrentWeather = Weather.GetCurrentWeather()
				While !Self.Is3DLoaded()
				enable()
				EndWhile
			CurrentWeather.ForceActive()
			debug.Notification ("WZONE ENABLED by OVERRIDE")
									If WZonesDebugMsg.Value >= 1
										debug.Trace ("WZMSG[1] : GetStatusScript : " +GetParentCell()+ " : ENABLED by OVERRIDE " +  WZonesSelectiveBattles)
									Else
									Endif
		endEvent
endState

State doneOnce
	; Extra Stopgap
	; Do Nothing until reset
	Event OnBeginState()
		If WZonesDebugMsg.Value >= 4	
			debug.Trace ("WZMSG[4] : GetStatusScript : State DoneOnce")
		Else
		Endif
		
		;Utility.WaitGameTime(WaitGameTimeToRecheck)
		
	EndEvent	
	
	Event OnUnload()
					While Self.Is3DLoaded()
					disable()
					EndWhile
	EndEvent

	Event OnCellDetach()
					While Self.Is3DLoaded()
					disable()
					EndWhile
	EndEvent
	
	
EndState


;============= GLOBALS, PROPERTIES and BOOLS, baby... yeah.

	ObjectReference Property WZonesGarrisonReference  Auto  
		{ For the GARRISON enable checker.	GARRISONREFERENCE manually selected in PROPERTIES.
		Select OBJECT REFERENCE which, when enabled, enables this.
		Use this to "hook" onto Vanilla Garrison Markers and the like. }
	
	Bool Property WZonesDoesCWMatterInThisLocation = True Auto 
		{CW VARIABLE is opposite of others in that 1 = OFF/OVER
		This checks to see if the CW is over, and if so, turn off IMPvSC
		Otherwise, if the WZ is Agnostic to the CW or takes place AFTER the CW
		set the BOOL WZonesDOESCWMATTERINTHISLOCATION to FALSE in PROPERTIES
		and it will skip the CW test.. }
	
	GlobalVariable Property WZonesCWStatus  Auto hidden 
		{  Checks status of CW.  This is mostly obsolete now that everything is parented, but still, gonna keep it for the few nonCW WZs }
	GlobalVariable Property WZonesCWTruce Auto hidden 
		{ ; === Truce? }
	GlobalVariable Property WZonesSpawnCount  Auto hidden 
		{ ; === Base Spawn count per NPC }
	GlobalVariable Property WZonesSpawnCountSONS Auto hidden  
		{ ; === Spawn count per STORMCLOAK NPC }
	GlobalVariable Property WZonesSpawnCountIMPS Auto hidden 
		{ ; === Spawn count per IMPERIAL NPC }
	GlobalVariable Property WZonesAdvantage Auto hidden
		{ ; ==== Who has the ADVANTAGE  }
	GlobalVariable Property WZonesSelectiveBattles Auto 
		{ ; === BATTLE SELECT Via PROPERTIES will hold the status of named Warzones. 
			WZONESSELECTIVEBATTLES manually assigned in PROPERTIES. 
					Points to WZonesSelectXXXXXX value
					WZonesSelectXXXXXX value is default 1
					0 = disable  1 = enable for game conditions 666 = Override and display }
	GlobalVariable Property WZonesOverride Auto hidden
		{ ; === Overrides everything and displays all battles. }
	GlobalVariable Property WZonesDebugMsg Auto hidden
		{ ; === Sets WZ DebugTrace Messages (0 = Off, 2 = Primary MSGs on, 3 = All MSGS on) }
	
	Quest Property MQ302 Auto hidden ;  = Checks the CW TRUCE.  300 = TRUCE
	Quest Property MQ305 Auto hidden ; = Is Alduin Dead?  If so, Truce is over.

	Quest Property CWObj Auto hidden
	Quest Property CW01A Auto hidden 
	Quest Property CW01B Auto hidden 
	Quest Property CW02A Auto hidden
	Quest Property CW02B Auto hidden
	Quest Property CW03 Auto hidden 
	Quest Property CWSiegeObj Auto hidden 
	Quest Property CWMission03 Auto hidden
	Quest Property CWMission04  Auto hidden
	Quest Property CWFortSiegeFort Auto hidden
	Quest Property CWMission07  Auto hidden

	Int Property SpawnPercentage = 100 Auto  
		{ ;==== DEVELOPER inputs value to increase odds of ENABLE }

	float Property WaitGameTimeToRecheck = 12.0 Auto 
		{  DEFAULT = 12.0 = 12 Game hours : A cooldown to have this stop checking for Enable after its made its "decision".  Allows the WZ to remain the same (whether Enabled or Randomly Disabled for a specific GameTime.  }


