Scriptname WZONESMonstersScript extends ObjectReference  
{

Checks to see if the PLAYER has activated the MONSTERS option, and if so, ENABLES WZONESvSPAWNMonsters

WARZONES MONSTERS Activator
	0 = Off
	1 = On/OneSpawn
	2 or more = SpawnCount

}

Event OnCellAttach()

	; utility.wait(1)

	; 3d checks added to exclude assigned creatures in unloaded cells - Deapri

	If WZonesOverride.getValue() == 666
		While Self.Is3DLoaded()
			disable()
		Endwhile
					; debug.Notification("WARZONES disabled by 666")
					; gotoState ("doneOnce")

    Elseif WZonesMonsters.getValue() <= 0	
		WZonesMonsters.setValue(0)
		While Self.Is3DLoaded()		
			Disable()
		Endwhile
					; debug.Notification ("Disabled because of SpawnCount")

	Else	
				; CLAMP it to 5 so the player doesn't fuck shit up.
				if WZonesMonsters.getValue() > 5
					WZonesMonsters.setValue(5)
				EndIf
	
					; debug.Notification("WZMSG : Monster Enabled: " + GetFormID() )
		While !Self.Is3DLoaded()		
			Enable()
		Endwhile
			
		int iX = WZonesMonsters.Value As Int        ; read the value from the global
		;iX = iX - 1 ; Bring the count down by one to account for spawn point (a value of 6 yields 7 NPCS for instance)
				if iX ; check non-zero
					If (MQ104.GetStageDone(160))
						
						float randomMonster = Utility.RandomFloat(1, 10)
						
						if randomMonster == 1
							PlaceAtMe(WZONESvSPAWNDragons, 1)
								If WZonesDebugMsg.Value >= 2
								debug.Trace("WZMSG[2] : MonstersScript : RUN! HIDE! PostDragon DRAGON!" + WZONESvSPAWNMonsters + iX)
								Else
								Endif
						else
							PlaceAtMe(WZONESvSPAWNMonsters, iX)
								If WZonesDebugMsg.Value >= 2
								debug.Trace("WZMSG[2] : MonstersScript : RUN! HIDE! PostDragon MONSTERS!" + WZONESvSPAWNMonsters + iX)
								Else
								Endif
						EndIf
						
					Else				
						PlaceAtMe(WZONESvSPAWNMonstersPreDragon, iX)
								If WZonesDebugMsg.Value >= 2
								debug.Trace("WZMSG[2] : MonstersScript : RUN! HIDE! PreDragon MONSTERS!" + WZONESvSPAWNMonsters + iX)
								Else
								Endif
					Endif
				Endif
    endif
	Gotostate("doneOnce")
EndEvent


State doneOnce
	; Extra Stopgap
	; Do Nothing until reset
	Event OnBeginState()
	; Waitin Around
	EndEvent
	
	Event OnUnload()
				While Self.Is3DLoaded()
				disable()
				EndWhile
									If WZonesDebugMsg.Value >= 4
									debug.Trace ("WZMSG[4] : MonstersScript : PLAYER Exited Area : Disable")
									EndIf		
	EndEvent	
	
EndState
ActorBase Property WZONESvSPAWNMonsters Auto 
	{ Via PROPERTY Window : The actor to spawn }
ActorBase Property WZONESvSPAWNMonstersPreDragon Auto 
	{ Via PROPERTY Window : The actor to spawn before DRAGON RISING is complete }
ActorBase Property WZONESvSPAWNDragons Auto 
	{ Via PROPERTY Window : Dragons Actor }

Quest Property MQ104 Auto hidden ; = DRAGON RISING Quest Complete

GlobalVariable Property WZonesMonsters Auto  
	{ Player Setting : Are Monsters On? 0 = Off, 1 = On }
GlobalVariable Property WZonesOverride Auto 
	{ Overrides everything and displays all battles. }
GlobalVariable Property WZonesDebugMsg Auto 
	{ Sets WZ DebugTrace Messages (0 = Off, 2 = Primary MSGs on, 3 = All MSGS on) }
