Scriptname WZones_ambushSpawner extends ObjectReference  
	
Event OnCellAttach()

;======== Check PLAYER ALIGNMENT
			;	0 = None (hasn't yet chosen sides)
			; 	1 = Imperial
			; 	2 = Sons
	
	if (CW01A.GetStageDone(200)) ; Player is IMPERIAL
		WzonesPlayerAlign.setValue(1)

	ElseIf (CW01B.GetStageDone(200)) ; Player is STORMCLOAK
		WzonesPlayerAlign.setValue(2)
	else
		WzonesPlayerAlign.setValue(0) ; not chosen yet
	endIf

;======== Check END of CIVIL WAR regardless of winner

	if (CWOBJ.GetStageDone(255))
		WZONESCWStatus.setValue(1)
			;	WZONESQuestID.setValue(200)
			;	debug.Notification ("WZonesCWStatus : Over")
	endif

	if (MQ302.GetStageDone(300)) 
		 WZonesCWTruce.setValue(1)
			If WZonesCWTruce.getValue() == 1 && (MQ305.GetStageDone(200))
			WZonesCWTruce.setValue(0)
			Else
			EndIf
		Else
	 EndIf	

; =========== Setup some stuff

	int iX = WZonesSpawnCount.Value As Int ; read the value from the global
	int iALIGN = WzonesPlayerAlign.Value As Int ; read the PLAYER ALIGNMENT

 	int randomDiceRoll = Utility.RandomInt (1, 100) ; Roll the Dice for a 1 in 100 chance that there should be an encounter.
	int randomEncounterOdds = WZonesRandomEncounterOdds.Value As Int ; USER INPUT number
			;If WZonesDebugMsg.Value >= 1	
				;debug.Trace ("WZMSG[1] : AmbushScript : PLAYER has ENTERED a RANDOM AMBUSH Area... roll 'dem bones")
				If WZonesDebugMsg.Value >= 2
					debug.Trace ("WZMSG[2] : AmbushScript : " +GetParentCell()+ " : RandomDICEroll = " + randomDiceRoll)
					debug.Trace ("WZMSG[2] : AmbushScript : " +GetParentCell()+ " : PlayerEncounterOdds + Developer Offset = " + (randomEncounterOdds + WZonesRaiseOdds))
				Else
				EndIf
			;Else
			;Endif
			
; ======= Is this ON?
; ======= iX = SpawnCount

	If iX <= 0
		While Self.Is3DLoaded()
		disable()
		EndWhile
	
	ElseIf WZonesRandomAmbush.getValue() == 0
		While Self.Is3DLoaded()
		disable()
		EndWhile

	ElseIf randomEncounterOdds + wzonesRaiseOdds <= randomDiceRoll
		While Self.Is3DLoaded()
		disable()
			If WZonesDebugMsg.Value >= 1	
			debug.Trace ("WZMSG[1] : AmbushScript : " +GetParentCell()+ " : High Dice : NoSpawn")
			endif
		EndWhile

;========= CONDITIONS
			
;========= CIVIL WAR IS OVER, but you still have some KILLING to do.

	ElseIf WZonesCWStatus.getValue() == 1 || WZONESCWTruce.getValue() == 1

			enable()

			int randomEnemies = Utility.RandomInt (1, 15)
			
						If WZonesDebugMsg.Value >= 1
						debug.Trace("WZMSG[1] : AmbushScript : " +GetParentCell()+ " : CW is over. AMBUSH!  Dice Roll " + randomEnemies)	
						endIf
	
				if randomEnemies == 1 
					GotoState ("SpawnStormcloaks")
					
				ElseIf randomEnemies == 2
					GotoState ("SpawnImperials")
				 
				ElseIf randomEnemies == 3
					GotoState ("SpawnSkirmishSCvIMP")
					
				ElseIf randomEnemies == 4
					GotoState ("TeamworkAmbushes")
					
				ElseIf randomEnemies == 5
					GotoState ("VersusAmbushes")
					
				ElseIf randomEnemies >= 6
					GotoState ("StandardAmbushes")
				 
				endIf
			
;========= PLAYER has chosen NO SIDE in the CW, but still... must kill.

	ElseIf iALIGN == 0

			enable()

			int randomEnemies = Utility.RandomInt (1, 10)
			
						If WZonesDebugMsg.Value >= 1
						debug.Trace("WZMSG[1] : AmbushScript : " +GetParentCell()+ " : Player is NEUTRAL!  AMBUSH!  Dice Roll " + randomEnemies)	
						endIf
	
				if randomEnemies == 1
					GotoState ("SpawnStormcloaks")
					
				ElseIf randomEnemies == 2
					GotoState ("SpawnImperials")
				 
				ElseIf randomEnemies == 3
					GotoState ("SpawnSkirmishSCvIMP")
				
				ElseIf randomEnemies == 4 
					GotoState ("VersusAmbushes")
									
				ElseIf randomEnemies >= 5
					GotoState ("StandardAmbushes")
							 
				endIf

;============== The player is an IMPERIAL

	ElseIf iALIGN == 1 

			enable()
		
			int randomEnemies = Utility.RandomInt (1, 10)
			
							If WZonesDebugMsg.Value >= 1
							debug.Trace("WZMSG[1] : AmbushScript : " +GetParentCell()+ " : Player is IMPERIAL!  AMBUSH!  Dice Roll " + randomEnemies)	
							endIf
				
				if randomEnemies == 1
					GotoState ("SpawnStormcloaks")
				 
				ElseIf randomEnemies == 2
					GotoState ("SpawnSkirmishSCvIMP")
					
				ElseIf randomEnemies == 3
					GotoState ("TeamworkAmbushes")
					
				ElseIf randomEnemies == 4
					GotoState ("VersusAmbushes")
					
				ElseIf randomEnemies >= 5
					GotoState ("StandardAmbushes")
				 
				endIf
				
				
;=============== The player is a STORMCLOAK

	ElseIf iALIGN == 2
	
			enable()
	
			int randomEnemies = Utility.RandomInt (1, 10)
			
						If WZonesDebugMsg.Value >= 1
						debug.Trace("WZMSG[1] : AmbushScript : " +GetParentCell()+ " : Player is Stormcloak!  AMBUSH!  Dice Roll " + randomEnemies)	
						endIf

				if randomEnemies == 1
					GotoState ("SpawnImperials")
				 
				ElseIf randomEnemies == 2
					GotoState ("SpawnSkirmishSCvIMP")
					
				ElseIf randomEnemies == 3
					GotoState ("TeamworkAmbushes")
					
				ElseIf randomEnemies == 4
					GotoState ("VersusAmbushes")
					
				ElseIf randomEnemies >= 5
					GotoState ("StandardAmbushes")
				 
				endIf
				
	endif
GotoState ("doneOnce")
EndEvent

;========== STATES

		State SkirmishSCvIMP
			Event OnBeginState()
					int iX = WZonesSpawnCount.Value As Int ; read the value from the global
					int randomExtraNPCS = Utility.RandomInt (1, 3)
					PlaceAtMe(WZONESvSPAWNSoldierImperial, iX + randomExtraNPCs)
					PlaceAtMe(WZONESvSPAWNSoldierSons, iX + randomExtraNPCs)	
							If WZonesDebugMsg.Value >= 3
							debug.Trace("WZMSG[3] : AmbushScript : " +GetParentCell()+ " : State = Skirmish")	
							endIf					
			EndEvent
		EndState

		State SpawnImperials
			Event OnBeginState()
				int iX = WZonesSpawnCount.Value As Int ; read the value from the global			
				int randomExtraNPCS = Utility.RandomInt (1, 3)
					PlaceAtMe(WZONESvSPAWNSoldierImperial, iX + randomExtraNPCs)
					
							If WZonesDebugMsg.Value >= 3
							debug.Trace("WZMSG[3] : AmbushScript : " +GetParentCell()+ " : State = SpawnImperials")	
							endIf
			EndEvent
		EndState
		
		State SpawnStormcloaks
			Event OnBeginState()
				int iX = WZonesSpawnCount.Value As Int ; read the value from the global	
				int randomExtraNPCS = Utility.RandomInt (1, 3)
					PlaceAtMe(WZONESvSPAWNSoldierSons, iX + randomExtraNPCs)
					
							If WZonesDebugMsg.Value >= 3
							debug.Trace("WZMSG[3] : AmbushScript : " +GetParentCell()+ " : State = SpawnStormcloaks")	
							endIf					
			EndEvent
		EndState
		
		State StandardAmbushes
			Event OnBeginState()
				int iX = WZonesSpawnCount.Value As Int ; read the value from the global
				int iALIGN = WzonesPlayerAlign.Value As Int ; read the PLAYER ALIGNMENT
				int standardAmbush = Utility.RandomInt (1, 6)
				int randomExtraNPCS = Utility.RandomInt (1, 3)

							If WZonesDebugMsg.Value >= 3
							debug.Trace("WZMSG[3] : AmbushScript : " +GetParentCell()+ " : State = StandardAmbushes " + standardAmbush)	
							endIf
							
				If standardAmbush == 1
					PlaceAtMe(WZONESvSPAWNactor03, iX + randomExtraNPCs)
					
				ElseIf standardAmbush == 2
					PlaceAtMe(WZONESvSPAWNactor04, iX + randomExtraNPCs)
					
				ElseIf standardAmbush == 3
					PlaceAtMe(WZONESvSPAWNactor05, iX + randomExtraNPCs)
					
				ElseIf standardAmbush == 4
					PlaceAtMe(WZONESvSPAWNactor06, iX + randomExtraNPCs)

				ElseIf standardAmbush == 5
					PlaceAtMe(WZONESvSPAWNactor07, iX + randomExtraNPCs)

				ElseIf standardAmbush == 6
					PlaceAtMe(WZONESvSPAWNactor08, iX + randomExtraNPCs)

				ElseIf standardAmbush == 7
					PlaceAtMe(WZONESvSPAWNactor09, iX + randomExtraNPCs)

				ElseIf standardAmbush == 8
					PlaceAtMe(WZONESvSPAWNactor10, iX + randomExtraNPCs)

				ElseIf standardAmbush == 9
					PlaceAtMe(WZONESvSPAWNactor11, iX + randomExtraNPCs)
				
				ElseIf standardAmbush == 10
					PlaceAtMe(WZONESvSPAWNactor12, iX + randomExtraNPCs)
				EndIf

			EndEvent
		EndState
	
		State TeamworkAmbushes
			Event OnBeginState()
				int iX = WZonesSpawnCount.Value As Int ; read the value from the global
				int iALIGN = WzonesPlayerAlign.Value As Int ; read the PLAYER ALIGNMENT
				int randomExtraNPCS = Utility.RandomInt (1, 3)				
				int Ambush = Utility.RandomInt (1, 4)
				
							If WZonesDebugMsg.Value >= 3
							debug.Trace("WZMSG[3] : AmbushScript : " +GetParentCell()+ " : State = TeamworkAmbushes " + Ambush)	
							endIf
							
				If Ambush == 1
					PlaceAtMe(WZONESvSPAWNactor17, iX + randomExtraNPCs)
						if iAlign == 2
							PlaceAtMe(WZONESvSPAWNSoldierSons, iX + randomExtraNPCs)
						ElseIf iAlign == 1
							PlaceAtMe(WZONESvSPAWNSoldierImperial, iX + randomExtraNPCs)
						endif

				ElseIf Ambush == 2
					PlaceAtMe(WZONESvSPAWNactor18, iX + randomExtraNPCs)
						if iAlign == 2
							PlaceAtMe(WZONESvSPAWNSoldierSons, iX + randomExtraNPCs)
						ElseIf iAlign == 1
							PlaceAtMe(WZONESvSPAWNSoldierImperial, iX + randomExtraNPCs)
						endif
						
				ElseIf Ambush == 3
					PlaceAtMe(WZONESvSPAWNactor19, iX + randomExtraNPCs)
						if iAlign == 2
							PlaceAtMe(WZONESvSPAWNSoldierSons, iX + randomExtraNPCs)
						ElseIf iAlign == 1
							PlaceAtMe(WZONESvSPAWNSoldierImperial, iX + randomExtraNPCs)
						endif

				ElseIf Ambush == 4
					PlaceAtMe(WZONESvSPAWNactor20, iX + randomExtraNPCs)
						if iAlign == 2
							PlaceAtMe(WZONESvSPAWNSoldierSons, iX + randomExtraNPCs)
						ElseIf iAlign == 1
							PlaceAtMe(WZONESvSPAWNSoldierImperial, iX + randomExtraNPCs)
						endif
				EndIf	
				
			EndEvent
		EndState
		
		State VersusAmbushes
			Event OnBeginState()
				; VERSUS Ambushes : To be used with VIGILLANTS and VAMPIRES, for instance
				; Daylight Aware for Dev Consideration of Werewolves and Vampires
				
				int Versus = Utility.RandomInt (1, 6)
				int iX = WZonesSpawnCount.Value As Int ; read the value from the global	
				int randomExtraNPCS = Utility.RandomInt (1, 3)

							If WZonesDebugMsg.Value >= 3
							debug.Trace("WZMSG[3] : AmbushScript : " +GetParentCell()+ " : State = VersusAmbushes " + Versus)	
							endIf
							
				If Versus == 1
						if GameHour.GetValue()  > 18.0 || GameHour.GetValue()  < 7.0 ; Is It Night?
							PlaceAtMe(WZONESvSPAWNnighttimeactor01, iX + randomExtraNPCs)
							PlaceAtMe(WZONESvSPAWNnighttimeactor02, iX + randomExtraNPCs)
						Else ; DAY!
							PlaceAtMe(WZONESvSPAWNversusactor01, iX + randomExtraNPCs)
							PlaceAtMe(WZONESvSPAWNversusactor02, iX + randomExtraNPCs)
						EndIf
					
				ElseIf Versus == 2
						if GameHour.GetValue()  > 18.0 || GameHour.GetValue()  < 7.0 ; Is It Night?
							PlaceAtMe(WZONESvSPAWNnighttimeactor03, iX + randomExtraNPCs)
							PlaceAtMe(WZONESvSPAWNnighttimeactor04, iX + randomExtraNPCs)
						Else ; DAY!
							PlaceAtMe(WZONESvSPAWNversusactor03, iX + randomExtraNPCs)
							PlaceAtMe(WZONESvSPAWNversusactor04, iX + randomExtraNPCs)
						EndIf
				ElseIf Versus == 3
						if GameHour.GetValue()  > 18.0 || GameHour.GetValue()  < 7.0 ; Is It Night?
							PlaceAtMe(WZONESvSPAWNnighttimeactor05, iX + randomExtraNPCs)
							PlaceAtMe(WZONESvSPAWNnighttimeactor06, iX + randomExtraNPCs)
						Else ; DAY!
							PlaceAtMe(WZONESvSPAWNversusactor05, iX + randomExtraNPCs)
							PlaceAtMe(WZONESvSPAWNversusactor06, iX + randomExtraNPCs)
						EndIf
				
				ElseIf Versus == 4
						if GameHour.GetValue()  > 18.0 || GameHour.GetValue()  < 7.0 ; Is It Night?
							PlaceAtMe(WZONESvSPAWNnighttimeactor01, iX + randomExtraNPCs - 1)
							PlaceAtMe(WZONESvSPAWNnighttimeactor02, iX + randomExtraNPCs)
						Else ; DAY!
							PlaceAtMe(WZONESvSPAWNversusactor01, iX + randomExtraNPCs - 1)
							PlaceAtMe(WZONESvSPAWNversusactor02, iX + randomExtraNPCs)
						EndIf

				ElseIf Versus == 5
						if GameHour.GetValue()  > 18.0 || GameHour.GetValue()  < 7.0 ; Is It Night?
							PlaceAtMe(WZONESvSPAWNnighttimeactor03, iX + randomExtraNPCs + 1)
							PlaceAtMe(WZONESvSPAWNnighttimeactor04, iX + randomExtraNPCs)
						Else ; DAY!
							PlaceAtMe(WZONESvSPAWNversusactor03, iX + randomExtraNPCs + 1)
							PlaceAtMe(WZONESvSPAWNversusactor04, iX + randomExtraNPCs)
						EndIf
	
				ElseIf Versus == 6
						if GameHour.GetValue()  > 18.0 || GameHour.GetValue()  < 7.0 ; Is It Night?
							PlaceAtMe(WZONESvSPAWNnighttimeactor05, iX + randomExtraNPCs + 1)
							PlaceAtMe(WZONESvSPAWNnighttimeactor06, iX + randomExtraNPCs)
						Else ; DAY!
							PlaceAtMe(WZONESvSPAWNversusactor05, iX + randomExtraNPCs + 1)
							PlaceAtMe(WZONESvSPAWNversusactor06, iX + randomExtraNPCs)
						EndIf
				EndIf

			EndEvent
		EndState

State doneOnce
	; Extra Stopgap
	; Do Nothing until reset
	Event OnBeginState()
		If WZonesDebugMsg.Value >= 4	
			debug.Trace ("WZMSG[4] : AmbushScript : " +GetParentCell()+ " : State DoneOnce")
		Else
		Endif
	EndEvent
	
	Event OnUnload()
				While Self.Is3DLoaded()
				disable()
				EndWhile
									If WZonesDebugMsg.Value >= 4
									debug.Trace ("WZMSG[4] : RandomEncountersScript : " +GetParentCell()+ " : PLAYER Exited Area : Disable")
									EndIf		
	EndEvent	
	
EndState

;====== GLOBALS, VARIABLES and WHATNOT

GlobalVariable Property WZonesSpawnCount Auto hidden; Global variable where iX is stored
GlobalVariable Property WzonesPlayerAlign Auto hidden; Player alignment based on completion of first CW missions
GlobalVariable Property WZonesRandomEncounters Auto hidden
GlobalVariable Property WZonesRandomEncounterOdds Auto hidden
GlobalVariable Property WZonesCWStatus Auto hidden
GlobalVariable Property WZONESCWTruce Auto ; = Is the CW TRUCE active?
GlobalVariable Property WZonesRandomAmbush Auto hidden
GlobalVariable Property WZonesDebugMsg Auto ; Sets WZ DEBUG MESSAGE LEVEL
GlobalVariable Property GameHour Auto

ActorBase Property WZONESvSPAWNSoldierImperial Auto 
ActorBase Property WZONESvSPAWNSoldierSons Auto 
ActorBase Property WZONESvSPAWNactor03 Auto ; Standard Ambush Actors
ActorBase Property WZONESvSPAWNactor04 Auto ;
ActorBase Property WZONESvSPAWNactor05 Auto ;
ActorBase Property WZONESvSPAWNactor06 Auto ;
ActorBase Property WZONESvSPAWNactor07 Auto ;
ActorBase Property WZONESvSPAWNactor08 Auto ;
ActorBase Property WZONESvSPAWNactor09 Auto ;
ActorBase Property WZONESvSPAWNactor10 Auto ;
ActorBase Property WZONESvSPAWNactor11 Auto ;
ActorBase Property WZONESvSPAWNactor12 Auto ;
ActorBase Property WZONESvSPAWNactor13 Auto ; DAYTIME Actor
ActorBase Property WZONESvSPAWNactor14 Auto ; DAYTIME Actor
ActorBase Property WZONESvSPAWNactor15 Auto ; DAYTIME Actor
ActorBase Property WZONESvSPAWNactor16 Auto ; DAYTIME Actor
ActorBase Property WZONESvSPAWNactor17 Auto ; Best if ENEMY of both CW FACTIONS
ActorBase Property WZONESvSPAWNactor18 Auto ; Best if ENEMY of both CW FACTIONS
ActorBase Property WZONESvSPAWNactor19 Auto ; Best if ENEMY of both CW FACTIONS
ActorBase Property WZONESvSPAWNactor20 Auto ; Best if ENEMY of both CW FACTIONS

; DAYTIME VERSUS Actors (don't use Werewolves or Vampires or the people will be pissy
;
ActorBase Property WZONESvSPAWNversusactor01 Auto ; 1 v 2 for DAYTIME VS
ActorBase Property WZONESvSPAWNversusactor02 Auto ;
ActorBase Property WZONESvSPAWNversusactor03 Auto ; 3 v 4
ActorBase Property WZONESvSPAWNversusactor04 Auto ;
ActorBase Property WZONESvSPAWNversusactor05 Auto ; 5 v 6
ActorBase Property WZONESvSPAWNversusactor06 Auto ;

; NIGHTTIME Actors, also used in VERSUS
; For instance, Werewolves V Silver Hand should be at night only

ActorBase Property WZONESvSPAWNnighttimeActor01 Auto ; 1 v 2
ActorBase Property WZONESvSPAWNnighttimeActor02 Auto ; 
ActorBase Property WZONESvSPAWNnighttimeActor03 Auto ; 3 v 4
ActorBase Property WZONESvSPAWNnighttimeActor04 Auto ;
ActorBase Property WZONESvSPAWNnighttimeActor05 Auto ; 5 v 6
ActorBase Property WZONESvSPAWNnighttimeActor06 Auto ;

Quest Property CW01A  Auto hidden
Quest Property CW01B  Auto hidden
Quest Property CWOBJ Auto hidden

Quest Property MQ302 Auto hidden ;  = Checks the CW TRUCE.  300 = TRUCE
Quest Property MQ305 Auto ; = Checks whether Alduin has been killed therefore TRUCE is over
 
Int Property wzonesRaiseOdds  Auto  

;====== 2014 - OBSOLETE BUT DANGEROUS TO REMOVE

ActorBase Property WZONESvSPAWNallEnemies Auto hidden; the player hasn't chosen or the CW is over
ActorBase Property WZONESvSPAWNAfflicted Auto hidden; ;
ActorBase Property WZONESvSPAWNBandits Auto hidden; ;
ActorBase Property WZONESvSPAWNDraugher Auto hidden; ;
ActorBase Property WZONESvSPAWNDunmer Auto hidden; ;
ActorBase Property WZONESvSPAWNForesworn Auto hidden; ;
ActorBase Property WZONESvSPAWNMages Auto hidden; ;
ActorBase Property WZONESvSPAWNRedguard Auto hidden; ;
ActorBase Property WZONESvSPAWNSkeletons Auto  hidden;;
ActorBase Property WZONESvSPAWNThalmor Auto hidden; ;
ActorBase Property WZONESLvlVampire Auto hidden; ;
ActorBase Property WZONESLvlWerewolf Auto hidden; ;
ActorBase Property WZONESLvlWitchAny Auto hidden; ;
ActorBase Property WZONESLvlEastEmpireMercenary Auto hidden; ;
ActorBase Property WZONESLvlEscapedPrisoner Auto hidden
ActorBase Property WZONESLvlOrcMelee Auto hidden; ;
ActorBase Property WZONESLvlWEAdventurer Auto hidden; ;
ActorBase Property WZONESvSpawnVigilantsOfStendarr Auto  hidden; ;
